#Использовать tempfiles
#Использовать v8unpack

Перем Лог;

// Распаковать контейнер метаданных
//
// Параметры:
//   ПутьФайлаДляРаспаковки - <Строка> - путь файла для распаковки
//   КаталогРаспаковки - <Строка> - каталог для распаковки
//
Процедура РаспаковатьКонтейнерМетаданных(Знач ФайлРаспаковки, Знач КаталогРаспаковки)
	ФайлДляРаспаковки = Новый файл(ФайлРаспаковки);
	Если КаталогРаспаковки = "" тогда
		КаталогРаспаковки = ВременныеФайлы.СоздатьКаталог();
	КонецЕсли;
	
	ЧтениеФайла8 = Новый ЧтениеФайла8(ФайлДляРаспаковки.ПолноеИмя);
	Для Каждого Элемент Из ЧтениеФайла8.Элементы Цикл
		ЧтениеФайла8.Извлечь(Элемент, КаталогРаспаковки, Истина);
	КонецЦикла;
	ЧтениеФайла8 = Неопределено;
	ВыполнитьСборкуМусора();

	ФайлМодуля = Новый Файл(ОбъединитьПути(КаталогРаспаковки, "module"));
	Если ФайлМодуля.Существует() Тогда 
		ФайлКуда = Новый Файл(ОбъединитьПути(ФайлМодуля.Путь, "Module.bsl"));
		Лог.Отладка("Перемещаю файл <%1> в <%2>", ФайлМодуля.ПолноеИмя, ФайлКуда.ПолноеИмя);
		Если ФайлКуда.Существует() Тогда
			УдалитьФайлы(ФайлКуда.ПолноеИмя);
		КонецЕсли;
		ПереместитьФайл(ФайлМодуля.ПолноеИмя, ФайлКуда.ПолноеИмя);
		Ожидаем.Что(ФайлКуда.Существует(), СтрШаблон("Файл должен существовать, а его нет. %1")).ЭтоИстина();
	КонецЕсли; 

КонецПроцедуры

// Упаковать контейнер метаданных
//
// Параметры:
//   КаталогРаспаковки - <Строка> - каталог для распаковки
//   ПутьФайлаДляРаспаковки - <Строка> - путь файла для упаковки
//
Процедура УпаковатьКонтейнерМетаданных(Знач КаталогРаспаковки, Знач ФайлРаспаковки)
	ФайлДляРаспаковки = Новый файл(ФайлРаспаковки);
	Если КаталогРаспаковки = "" тогда
		КаталогРаспаковки = ВременныеФайлы.СоздатьКаталог();
	КонецЕсли;
	ФайлПрограммыРаспаковки = ИмяПрограммыРаспаковки();
	ФайлМодуля = Новый Файл(ОбъединитьПути(КаталогРаспаковки, "Module.bsl"));
	Если ФайлМодуля.Существует() Тогда
		КопироватьФайл(ФайлМодуля.ПолноеИмя, ОбъединитьПути(ФайлМодуля.Путь, "module") );
	КонецЕсли;
	СтрокаЗапуска = """"+ФайлПрограммыРаспаковки+""" -build -nopack """+КаталогРаспаковки+""" """+ФайлДляРаспаковки.ПолноеИмя+"""";
	Если НЕ ПараметрыСистемы.ЭтоWindows Тогда 
		СтрокаЗапуска = "sh -c '"+СтрокаЗапуска+"'";
	КонецЕсли;
	Лог.Отладка(СтрокаЗапуска);

	ЗапуститьПриложение(СтрокаЗапуска,,Истина);

КонецПроцедуры

Процедура ВыполнитьКоманду(Знач СтрокаЗапуска)
	
	Лог.Отладка(СтрокаЗапуска);

	Команда = Новый Команда;
	Команда.УстановитьПравильныйКодВозврата(0);
	Команда.УстановитьСтрокуЗапуска(СтрокаЗапуска);
	Команда.Исполнить();
КонецПроцедуры

Функция ИмяПрограммыРаспаковки()
	Рез = "v8unpack";
	Если ПараметрыСистемы.ЭтоWindows Тогда
		Рез = Рез + ".exe";
	КонецЕсли;
	Возврат Рез;
КонецФункции // ИмяПрограммыРаспаковки()

Функция ПолучитьЛог()
	Если Лог = Неопределено Тогда
		Лог = Логирование.ПолучитьЛог(ПараметрыСистемы.ИмяЛогаСистемы());
	КонецЕсли;
	Возврат Лог;	
КонецФункции
